--- net/minecraft/src/ItemPainting.java
+++ net/minecraft/src/ItemPainting.java
@@ -27,7 +27,9 @@
 
 			EntityPainting var9 = new EntityPainting(var3, var4, var5, var6, var8);
 			if(var9.onValidSurface()) {
-				var3.spawnEntityInWorld(var9);
+				if(!var3.multiplayerWorld) {
+					var3.spawnEntityInWorld(var9);
+				}
 				--var1.stackSize;
 			}
 
--- /dev/null
+++ net/minecraft/src/Packet70Bed.java
@@ -1,0 +1,26 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet70Bed extends Packet {
+	public static final String[] field_25020_a = new String[]{"tile.bed.notValid", null, null};
+	public int field_25019_b;
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.field_25019_b = var1.readByte();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeByte(this.field_25019_b);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_25118_a(this);
+	}
+
+	public int getPacketSize() {
+		return 1;
+	}
+}
--- net/minecraft/src/EntityCreeper.java
+++ net/minecraft/src/EntityCreeper.java
@@ -4,13 +4,17 @@
 	int timeSinceIgnited;
 	int lastActiveTime;
 	int fuseDuration = 30;
-	int creeperState = -1;
 
 	public EntityCreeper(World var1) {
 		super(var1);
 		this.texture = "/mob/creeper.png";
 	}
 
+	protected void entityInit() {
+		super.entityInit();
+		this.dataWatcher.addObject(16, Byte.valueOf((byte)-1));
+	}
+
 	public void writeEntityToNBT(NBTTagCompound var1) {
 		super.writeEntityToNBT(var1);
 	}
@@ -18,20 +22,45 @@
 	public void readEntityFromNBT(NBTTagCompound var1) {
 		super.readEntityFromNBT(var1);
 	}
-
-	protected void updateEntityActionState() {
+	
+	protected void attackBlockedEntity(Entity var1, float var2) {
+		if(!this.worldObj.multiplayerWorld) {
+			if(this.timeSinceIgnited > 0) {
+				this.setCreeperState(-1);
+				--this.timeSinceIgnited;
+				if(this.timeSinceIgnited < 0) {
+					this.timeSinceIgnited = 0;
+				}
+			}
+
+		}
+	}
+
+	public void onUpdate() {
 		this.lastActiveTime = this.timeSinceIgnited;
-		if(this.timeSinceIgnited > 0 && this.creeperState < 0) {
+		if(this.worldObj.multiplayerWorld) {
+			int var1 = this.getCreeperState();
+			if(var1 > 0 && this.timeSinceIgnited == 0) {
+				//this.worldObj.playSoundAtEntity(this, "random.fuse", 1.0F, 0.5F);
+			}
+
+			this.timeSinceIgnited += var1;
+			if(this.timeSinceIgnited < 0) {
+				this.timeSinceIgnited = 0;
+			}
+
+			if(this.timeSinceIgnited >= 30) {
+				this.timeSinceIgnited = 30;
+			}
+		}
+
+		super.onUpdate();
+		if(this.entityToAttack == null && this.timeSinceIgnited > 0) {
+			this.setCreeperState(-1);
 			--this.timeSinceIgnited;
-		}
-
-		if(this.creeperState >= 0) {
-			this.creeperState = 2;
-		}
-
-		super.updateEntityActionState();
-		if(this.creeperState != 1) {
-			this.creeperState = -1;
+			if(this.timeSinceIgnited < 0) {
+				this.timeSinceIgnited = 0;
+			}
 		}
 
 	}
@@ -53,12 +82,16 @@
 	}
 
 	protected void attackEntity(Entity var1, float var2) {
-		if(this.creeperState <= 0 && var2 < 3.0F || this.creeperState > 0 && var2 < 7.0F) {
+		if(this.worldObj.multiplayerWorld)
+			return;
+
+		int creeperState = this.getCreeperState();
+		if(creeperState <= 0 && var2 < 3.0F || creeperState > 0 && var2 < 7.0F) {
 			if(this.timeSinceIgnited == 0) {
 				this.worldObj.playSoundAtEntity(this, "random.fuse", 1.0F, 0.5F);
 			}
 
-			this.creeperState = 1;
+			this.setCreeperState(1);
 			++this.timeSinceIgnited;
 			if(this.timeSinceIgnited == this.fuseDuration) {
 				this.worldObj.createExplosion(this, this.posX, this.posY, this.posZ, 3.0F);
@@ -66,6 +99,12 @@
 			}
 
 			this.hasAttacked = true;
+		} else {
+			this.setCreeperState(-1);
+			--this.timeSinceIgnited;
+			if(this.timeSinceIgnited < 0) {
+				this.timeSinceIgnited = 0;
+			}
 		}
 
 	}
@@ -76,5 +115,13 @@
 
 	protected int getDropItemId() {
 		return Item.gunpowder.shiftedIndex;
+	}
+	
+	private int getCreeperState() {
+		return this.dataWatcher.getWatchableObjectByte(16);
+	}
+
+	private void setCreeperState(int var1) {
+		this.dataWatcher.updateObject(16, Byte.valueOf((byte)var1));
 	}
 }
--- net/minecraft/src/GuiIngame.java
+++ net/minecraft/src/GuiIngame.java
@@ -286,6 +286,10 @@
 
 	}
 
+	public void clearChatMessages() {
+		this.chatMessageList.clear();
+	}
+
 	public void addChatMessage(String var1) {
 		while(this.mc.fontRenderer.getStringWidth(var1) > 320) {
 			int var2;
--- net/minecraft/src/ItemHoe.java
+++ net/minecraft/src/ItemHoe.java
@@ -16,7 +16,10 @@
 			Block var10 = Block.tilledField;
 			var3.playSoundEffect((double)((float)var4 + 0.5F), (double)((float)var5 + 0.5F), (double)((float)var6 + 0.5F), var10.stepSound.getStepSound(), (var10.stepSound.getVolume() + 1.0F) / 2.0F, var10.stepSound.getPitch() * 0.8F);
 			var3.setBlockWithNotify(var4, var5, var6, var10.blockID);
-			var1.damageItem(1);
+			if(var3.multiplayerWorld) {
+				return true;
+			}
+			var1.damageItem(1, var2);
 			if(var3.rand.nextInt(8) == 0 && var8 == Block.grass.blockID) {
 				byte var11 = 1;
 
--- /dev/null
+++ net/minecraft/src/Packet104WindowItems.java
@@ -1,0 +1,50 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet104WindowItems extends Packet {
+	public int windowId;
+	public ItemStack[] itemStack;
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.windowId = var1.readByte();
+		short var2 = var1.readShort();
+		this.itemStack = new ItemStack[var2];
+
+		for(int var3 = 0; var3 < var2; ++var3) {
+			short var4 = var1.readShort();
+			if(var4 >= 0) {
+				byte var5 = var1.readByte();
+				short var6 = var1.readShort();
+				this.itemStack[var3] = new ItemStack(var4, var5, var6);
+			}
+		}
+
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeByte(this.windowId);
+		var1.writeShort(this.itemStack.length);
+
+		for(int var2 = 0; var2 < this.itemStack.length; ++var2) {
+			if(this.itemStack[var2] == null) {
+				var1.writeShort(-1);
+			} else {
+				var1.writeShort((short)this.itemStack[var2].itemID);
+				var1.writeByte((byte)this.itemStack[var2].stackSize);
+				var1.writeShort((short)this.itemStack[var2].getItemDamage());
+			}
+		}
+
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_20094_a(this);
+	}
+
+	public int getPacketSize() {
+		return 3 + this.itemStack.length * 5;
+	}
+}
--- /dev/null
+++ net/minecraft/src/ShapedRecipes.java
@@ -1,0 +1,75 @@
+package net.minecraft.src;
+
+public class ShapedRecipes implements IRecipe {
+	private int recipeWidth;
+	private int recipeHeight;
+	private int[] recipeItems;
+	private ItemStack recipeOutput;
+	public final int recipeOutputItemID;
+
+	public ShapedRecipes(int var1, int var2, int[] var3, ItemStack var4) {
+		this.recipeOutputItemID = var4.itemID;
+		this.recipeWidth = var1;
+		this.recipeHeight = var2;
+		this.recipeItems = var3;
+		this.recipeOutput = var4;
+	}
+
+	public ItemStack getRecipeOutput() {
+		return this.recipeOutput;
+	}
+
+	public boolean matches(InventoryCrafting var1) {
+		for(int var2 = 0; var2 <= 3 - this.recipeWidth; ++var2) {
+			for(int var3 = 0; var3 <= 3 - this.recipeHeight; ++var3) {
+				if(this.func_21137_a(var1, var2, var3, true)) {
+					return true;
+				}
+
+				if(this.func_21137_a(var1, var2, var3, false)) {
+					return true;
+				}
+			}
+		}
+
+		return false;
+	}
+
+	private boolean func_21137_a(InventoryCrafting var1, int var2, int var3, boolean var4) {
+		for(int var5 = 0; var5 < 3; ++var5) {
+			for(int var6 = 0; var6 < 3; ++var6) {
+				int var7 = var5 - var2;
+				int var8 = var6 - var3;
+				int var9 = -1;
+				if(var7 >= 0 && var8 >= 0 && var7 < this.recipeWidth && var8 < this.recipeHeight) {
+					if(var4) {
+						var9 = this.recipeItems[this.recipeWidth - var7 - 1 + var8 * this.recipeWidth];
+					} else {
+						var9 = this.recipeItems[var7 + var8 * this.recipeWidth];
+					}
+				}
+
+				ItemStack var10 = var1.func_21103_b(var5, var6);
+				if(var10 != null || var9 != -1) {
+					if(var10 == null && var9 != -1 || var10 != null && var9 == -1) {
+						return false;
+					}
+
+					if(var9 != var10.itemID) {
+						return false;
+					}
+				}
+			}
+		}
+
+		return true;
+	}
+
+	public ItemStack getCraftingResult(InventoryCrafting var1) {
+		return new ItemStack(this.recipeOutput.itemID, this.recipeOutput.stackSize, this.recipeOutput.getItemDamage());
+	}
+
+	public int getRecipeSize() {
+		return this.recipeWidth * this.recipeHeight;
+	}
+}
--- net/minecraft/src/Packet14BlockDig.java
+++ net/minecraft/src/Packet14BlockDig.java
@@ -30,7 +30,7 @@
 		this.face = var1.read();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.write(this.status);
 		var1.writeInt(this.xPosition);
 		var1.write(this.yPosition);
--- net/minecraft/src/BlockJukeBox.java
+++ net/minecraft/src/BlockJukeBox.java
@@ -20,16 +20,18 @@
 	}
 
 	public void ejectRecord(World var1, int var2, int var3, int var4, int var5) {
-		var1.playRecord((String)null, var2, var3, var4);
-		var1.setBlockMetadataWithNotify(var2, var3, var4, 0);
-		int var6 = Item.record13.shiftedIndex + var5 - 1;
-		float var7 = 0.7F;
-		double var8 = (double)(var1.rand.nextFloat() * var7) + (double)(1.0F - var7) * 0.5D;
-		double var10 = (double)(var1.rand.nextFloat() * var7) + (double)(1.0F - var7) * 0.2D + 0.6D;
-		double var12 = (double)(var1.rand.nextFloat() * var7) + (double)(1.0F - var7) * 0.5D;
-		EntityItem var14 = new EntityItem(var1, (double)var2 + var8, (double)var3 + var10, (double)var4 + var12, new ItemStack(var6));
-		var14.delayBeforeCanPickup = 10;
-		var1.spawnEntityInWorld(var14);
+		if(!var1.multiplayerWorld) {
+			var1.playRecord((String)null, var2, var3, var4);
+			var1.setBlockMetadataWithNotify(var2, var3, var4, 0);
+			int var6 = Item.record13.shiftedIndex + var5 - 1;
+			float var7 = 0.7F;
+			double var8 = (double)(var1.rand.nextFloat() * var7) + (double)(1.0F - var7) * 0.5D;
+			double var10 = (double)(var1.rand.nextFloat() * var7) + (double)(1.0F - var7) * 0.2D + 0.6D;
+			double var12 = (double)(var1.rand.nextFloat() * var7) + (double)(1.0F - var7) * 0.5D;
+			EntityItem var14 = new EntityItem(var1, (double)var2 + var8, (double)var3 + var10, (double)var4 + var12, new ItemStack(var6, 1, 0));
+			var14.delayBeforeCanPickup = 10;
+			var1.spawnEntityInWorld(var14);
+		}
 	}
 
 	public void dropBlockAsItemWithChance(World var1, int var2, int var3, int var4, int var5, float var6) {
--- net/minecraft/src/Packet21PickupSpawn.java
+++ net/minecraft/src/Packet21PickupSpawn.java
@@ -14,6 +14,7 @@
 	public byte roll;
 	public int itemID;
 	public int count;
+	public int itemDamage;
 
 	public Packet21PickupSpawn() {
 	}
@@ -22,6 +23,7 @@
 		this.entityId = var1.entityID;
 		this.itemID = var1.item.itemID;
 		this.count = var1.item.stackSize;
+		this.itemDamage = var1.item.getItemDamage();
 		this.xPosition = MathHelper.floor_double(var1.posX * 32.0D);
 		this.yPosition = MathHelper.floor_double(var1.posY * 32.0D);
 		this.zPosition = MathHelper.floor_double(var1.posZ * 32.0D);
@@ -34,6 +36,7 @@
 		this.entityId = var1.readInt();
 		this.itemID = var1.readShort();
 		this.count = var1.readByte();
+		this.itemDamage = var1.readShort();
 		this.xPosition = var1.readInt();
 		this.yPosition = var1.readInt();
 		this.zPosition = var1.readInt();
@@ -42,10 +45,11 @@
 		this.roll = var1.readByte();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.entityId);
 		var1.writeShort(this.itemID);
 		var1.writeByte(this.count);
+		var1.writeShort(this.itemDamage);
 		var1.writeInt(this.xPosition);
 		var1.writeInt(this.yPosition);
 		var1.writeInt(this.zPosition);
@@ -59,6 +63,6 @@
 	}
 
 	public int getPacketSize() {
-		return 22;
+		return 24;
 	}
 }
--- net/minecraft/src/NetworkManager.java
+++ net/minecraft/src/NetworkManager.java
@@ -1,11 +1,14 @@
 package net.minecraft.src;
 
+import java.io.BufferedOutputStream;
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 import java.net.Socket;
+import java.net.SocketAddress;
+import java.net.SocketException;
+import java.util.ArrayList;
 import java.util.Collections;
-import java.util.LinkedList;
 import java.util.List;
 
 public class NetworkManager {
@@ -14,28 +17,42 @@
 	public static int numWriteThreads;
 	private Object sendQueueLock = new Object();
 	private Socket networkSocket;
+	private final SocketAddress remoteSocketAddress;
 	private DataInputStream socketInputStream;
 	private DataOutputStream socketOutputStream;
 	private boolean isRunning = true;
-	private List readPackets = Collections.synchronizedList(new LinkedList());
-	private List dataPackets = Collections.synchronizedList(new LinkedList());
-	private List chunkDataPackets = Collections.synchronizedList(new LinkedList());
+	private List readPackets = Collections.synchronizedList(new ArrayList());
+	private List dataPackets = Collections.synchronizedList(new ArrayList());
+	private List chunkDataPackets = Collections.synchronizedList(new ArrayList());
 	private NetHandler netHandler;
 	private boolean isServerTerminating = false;
 	private Thread writeThread;
 	private Thread readThread;
 	private boolean isTerminating = false;
 	private String terminationReason = "";
+	private Object[] field_20101_t;
 	private int timeSinceLastRead = 0;
 	private int sendQueueByteLength = 0;
-	private int chunkDataSendCounter = 0;
+	public static int[] field_28145_d = new int[256];
+	public static int[] field_28144_e = new int[256];
+	public int chunkDataSendCounter = 0;
+	private int field_20100_w = 50;
 
 	public NetworkManager(Socket var1, String var2, NetHandler var3) throws IOException {
 		this.networkSocket = var1;
+		this.remoteSocketAddress = var1.getRemoteSocketAddress();
 		this.netHandler = var3;
-		var1.setTrafficClass(24);
+
+		try {
+			var1.setSoTimeout(30000);
+			var1.setTcpNoDelay(true);
+			var1.setTrafficClass(24);
+		} catch (SocketException var5) {
+			System.err.println(var5.getMessage());
+		}
+
 		this.socketInputStream = new DataInputStream(var1.getInputStream());
-		this.socketOutputStream = new DataOutputStream(var1.getOutputStream());
+		this.socketOutputStream = new DataOutputStream(new BufferedOutputStream(var1.getOutputStream(), 5120));
 		this.readThread = new NetworkReaderThread(this, var2 + " read thread");
 		this.writeThread = new NetworkWriterThread(this, var2 + " write thread");
 		this.readThread.start();
@@ -57,13 +74,15 @@
 		}
 	}
 
-	private void sendPacket() {
+	private boolean sendPacket() {
+		boolean var1 = false;
+
 		try {
-			boolean var1 = true;
+			int[] var10000;
+			int var10001;
 			Packet var2;
 			Object var3;
-			if(!this.dataPackets.isEmpty()) {
-				var1 = false;
+			if(!this.dataPackets.isEmpty() && (this.chunkDataSendCounter == 0 || System.currentTimeMillis() - ((Packet)this.dataPackets.get(0)).creationTimeMillis >= (long)this.chunkDataSendCounter)) {
 				var3 = this.sendQueueLock;
 				synchronized(var3) {
 					var2 = (Packet)this.dataPackets.remove(0);
@@ -71,10 +90,13 @@
 				}
 
 				Packet.writePacket(var2, this.socketOutputStream);
+				var10000 = field_28144_e;
+				var10001 = var2.getPacketId();
+				var10000[var10001] += var2.getPacketSize() + 1;
+				var1 = true;
 			}
 
-			if((var1 || this.chunkDataSendCounter-- <= 0) && !this.chunkDataPackets.isEmpty()) {
-				var1 = false;
+			if(this.field_20100_w-- <= 0 && !this.chunkDataPackets.isEmpty() && (this.chunkDataSendCounter == 0 || System.currentTimeMillis() - ((Packet)this.chunkDataPackets.get(0)).creationTimeMillis >= (long)this.chunkDataSendCounter)) {
 				var3 = this.sendQueueLock;
 				synchronized(var3) {
 					var2 = (Packet)this.chunkDataPackets.remove(0);
@@ -82,35 +104,51 @@
 				}
 
 				Packet.writePacket(var2, this.socketOutputStream);
-				this.chunkDataSendCounter = 50;
+				var10000 = field_28144_e;
+				var10001 = var2.getPacketId();
+				var10000[var10001] += var2.getPacketSize() + 1;
+				this.field_20100_w = 0;
+				var1 = true;
 			}
 
-			if(var1) {
-				Thread.sleep(10L);
-			}
-		} catch (InterruptedException var8) {
-		} catch (Exception var9) {
+			return var1;
+		} catch (Exception var8) {
 			if(!this.isTerminating) {
-				this.onNetworkError(var9);
+				this.onNetworkError(var8);
 			}
+
+			return false;
 		}
-
-	}
-
-	private void readPacket() {
+	}
+
+	public void wakeThreads() {
+		this.readThread.interrupt();
+		this.writeThread.interrupt();
+	}
+
+	private boolean readPacket() {
+		boolean var1 = false;
+
 		try {
-			Packet var1 = Packet.readPacket(this.socketInputStream);
-			if(var1 != null) {
-				this.readPackets.add(var1);
+			Packet var2 = Packet.readPacket(this.socketInputStream, this.netHandler.isServerHandler());
+			if(var2 != null) {
+				int[] var10000 = field_28145_d;
+				int var10001 = var2.getPacketId();
+				var10000[var10001] += var2.getPacketSize() + 1;
+				this.readPackets.add(var2);
+				var1 = true;
 			} else {
-				this.networkShutdown("End of stream");
+				this.networkShutdown("End of stream", new Object[0]);
 			}
-		} catch (Exception var2) {
+
+			return var1;
+		} catch (Exception var3) {
 			if(!this.isTerminating) {
-				this.onNetworkError(var2);
+				this.onNetworkError(var3);
 			}
+
+			return false;
 		}
-
 	}
 
 	private void onNetworkError(Exception var1) {
@@ -118,26 +156,33 @@
 		this.networkShutdown("Internal exception: " + var1.toString());
 	}
 
-	public void networkShutdown(String var1) {
+	public void networkShutdown(String var1, Object... var2) {
 		if(this.isRunning) {
+			if (var2 == null) {
+				var2 = new Object[0];
+			}
 			this.isTerminating = true;
 			this.terminationReason = var1;
+			this.field_20101_t = var2;
 			(new NetworkMasterThread(this)).start();
 			this.isRunning = false;
 
 			try {
 				this.socketInputStream.close();
-			} catch (Throwable var5) {
+				this.socketInputStream = null;
+			} catch (Throwable var6) {
 			}
 
 			try {
 				this.socketOutputStream.close();
-			} catch (Throwable var4) {
+				this.socketOutputStream = null;
+			} catch (Throwable var5) {
 			}
 
 			try {
 				this.networkSocket.close();
-			} catch (Throwable var3) {
+				this.networkSocket = null;
+			} catch (Throwable var4) {
 			}
 
 		}
@@ -145,14 +190,15 @@
 
 	public void processReadPackets() {
 		if(this.sendQueueByteLength > 1048576) {
-			this.networkShutdown("Send buffer overflow");
+			this.networkShutdown("Send buffer overflow", new Object[0]);
 		}
 
 		if(this.readPackets.isEmpty()) {
 			if(this.timeSinceLastRead++ == 1200) {
-				this.networkShutdown("Timed out");
+				this.networkShutdown("Timed out", new Object[0]);
 			}
 		} else {
+			
 			this.timeSinceLastRead = 0;
 		}
 
@@ -163,10 +209,18 @@
 			var2.processPacket(this.netHandler);
 		}
 
+		this.wakeThreads();
 		if(this.isTerminating && this.readPackets.isEmpty()) {
-			this.netHandler.handleErrorMessage(this.terminationReason);
+			this.netHandler.handleErrorMessage(this.terminationReason, this.field_20101_t);
 		}
 
+	}
+
+	public void func_28142_c() {
+		this.wakeThreads();
+		this.isServerTerminating = true;
+		this.readThread.interrupt();
+		(new ThreadCloseConnection(this)).start();
 	}
 
 	static boolean isRunning(NetworkManager var0) {
@@ -177,12 +231,24 @@
 		return var0.isServerTerminating;
 	}
 
-	static void readNetworkPacket(NetworkManager var0) {
-		var0.readPacket();
-	}
-
-	static void sendNetworkPacket(NetworkManager var0) {
-		var0.sendPacket();
+	static boolean readNetworkPacket(NetworkManager var0) {
+		return var0.readPacket();
+	}
+
+	static boolean sendNetworkPacket(NetworkManager var0) {
+		return var0.sendPacket();
+	}
+
+	static DataOutputStream func_28140_f(NetworkManager var0) {
+		return var0.socketOutputStream;
+	}
+
+	static boolean func_28138_e(NetworkManager var0) {
+		return var0.isTerminating;
+	}
+
+	static void func_30005_a(NetworkManager var0, Exception var1) {
+		var0.onNetworkError(var1);
 	}
 
 	static Thread getReadThread(NetworkManager var0) {
--- net/minecraft/src/RenderMinecart.java
+++ net/minecraft/src/RenderMinecart.java
@@ -60,9 +60,9 @@
 			GL11.glTranslatef(0.0F, 5.0F / 16.0F, 0.0F);
 			GL11.glRotatef(90.0F, 0.0F, 1.0F, 0.0F);
 			if(var1.minecartType == 1) {
-				(new RenderBlocks()).renderBlockOnInventory(Block.chest);
+				(new RenderBlocks()).renderBlockOnInventory(Block.chest, 0);
 			} else if(var1.minecartType == 2) {
-				(new RenderBlocks()).renderBlockOnInventory(Block.stoneOvenIdle);
+				(new RenderBlocks()).renderBlockOnInventory(Block.stoneOvenIdle, 0);
 			}
 
 			GL11.glRotatef(-90.0F, 0.0F, 1.0F, 0.0F);
--- net/minecraft/src/EntityFallingSand.java
+++ net/minecraft/src/EntityFallingSand.java
@@ -8,20 +8,23 @@
 		super(var1);
 	}
 
-	public EntityFallingSand(World var1, float var2, float var3, float var4, int var5) {
+	public EntityFallingSand(World var1, double var2, double var3, double var4, int var5) {
 		super(var1);
 		this.blockID = var5;
 		this.preventEntitySpawning = true;
 		this.setSize(0.98F, 0.98F);
 		this.yOffset = this.height / 2.0F;
-		this.setPosition((double)var2, (double)var3, (double)var4);
+		this.setPosition(var2, var3, var4);
 		this.motionX = 0.0D;
 		this.motionY = 0.0D;
 		this.motionZ = 0.0D;
 		this.canTriggerWalking = false;
-		this.prevPosX = (double)var2;
-		this.prevPosY = (double)var3;
-		this.prevPosZ = (double)var4;
+		this.prevPosX = var2;
+		this.prevPosY = var3;
+		this.prevPosZ = var4;
+	}
+
+	protected void entityInit() {
 	}
 
 	public boolean canBeCollidedWith() {
@@ -53,11 +56,13 @@
 				this.motionZ *= (double)0.7F;
 				this.motionY *= -0.5D;
 				this.setEntityDead();
-				if(!this.worldObj.canBlockBePlacedAt(this.blockID, var1, var2, var3, true) || !this.worldObj.setBlockWithNotify(var1, var2, var3, this.blockID)) {
+				if((!this.worldObj.canBlockBePlacedAt(this.blockID, var1, var2, var3, true) || !this.worldObj.setBlockWithNotify(var1, var2, var3, this.blockID)) && !this.worldObj.multiplayerWorld) {
 					this.dropItem(this.blockID, 1);
 				}
 			} else if(this.fallTime > 100) {
-				this.dropItem(this.blockID, 1);
+				if (!this.worldObj.multiplayerWorld)
+					this.dropItem(this.blockID, 1);
+				
 				this.setEntityDead();
 			}
 
--- net/minecraft/src/TileEntityFurnace.java
+++ net/minecraft/src/TileEntityFurnace.java
@@ -1,10 +1,10 @@
 package net.minecraft.src;
 
 public class TileEntityFurnace extends TileEntity implements IInventory {
-	private ItemStack[] furnaceItemStacks = new ItemStack[3];
-	private int furnaceBurnTime = 0;
-	private int currentItemBurnTime = 0;
-	private int furnaceCookTime = 0;
+	public ItemStack[] furnaceItemStacks = new ItemStack[3];
+	public int furnaceBurnTime = 0;
+	public int currentItemBurnTime = 0;
+	public int furnaceCookTime = 0;
 
 	public int getSizeInventory() {
 		return this.furnaceItemStacks.length;
@@ -159,7 +159,7 @@
 		if(this.canSmelt()) {
 			int var1 = this.getCookedItem(this.furnaceItemStacks[0].getItem().shiftedIndex);
 			if(this.furnaceItemStacks[2] == null) {
-				this.furnaceItemStacks[2] = new ItemStack(var1, 1);
+				this.furnaceItemStacks[2] = new ItemStack(var1, 1, 0);
 			} else if(this.furnaceItemStacks[2].itemID == var1) {
 				++this.furnaceItemStacks[2].stackSize;
 			}
@@ -183,5 +183,9 @@
 			int var2 = var1.getItem().shiftedIndex;
 			return var2 < 256 && Block.blocksList[var2].material == Material.wood ? 300 : (var2 == Item.stick.shiftedIndex ? 100 : (var2 == Item.coal.shiftedIndex ? 1600 : (var2 == Item.bucketLava.shiftedIndex ? 20000 : 0)));
 		}
+	}
+	
+	public boolean canInteractWith(EntityPlayer var1) {
+		return this.worldObj.getBlockTileEntity(this.xCoord, this.yCoord, this.zCoord) != this ? false : var1.getDistanceSq((double)this.xCoord + 0.5D, (double)this.yCoord + 0.5D, (double)this.zCoord + 0.5D) <= 64.0D;
 	}
 }
--- /dev/null
+++ net/minecraft/src/SlotFurnace.java
@@ -1,0 +1,20 @@
+package net.minecraft.src;
+
+public class SlotFurnace extends Slot {
+	private EntityPlayer thePlayer;
+
+	public SlotFurnace(EntityPlayer var1, IInventory var2, int var3, int var4, int var5) {
+		super(var2, var3, var4, var5);
+		this.thePlayer = var1;
+	}
+
+	public boolean isItemValid(ItemStack var1) {
+		return false;
+	}
+
+	public void onPickupFromSlot(ItemStack var1) {
+		var1.onCrafting(this.thePlayer.worldObj, this.thePlayer);
+
+		super.onPickupFromSlot(var1);
+	}
+}
--- net/minecraft/src/CraftingManager.java
+++ net/minecraft/src/CraftingManager.java
@@ -110,12 +110,35 @@
 			}
 		}
 
-		this.recipes.add(new CraftingRecipe(var5, var6, var14, var1));
-	}
-
-	public ItemStack findMatchingRecipe(int[] var1) {
+		this.recipes.add(new ShapedRecipes(var5, var6, var14, var1));
+	}
+	
+	void addShapelessRecipe(ItemStack var1, Object... var2) {
+		ArrayList var3 = new ArrayList();
+		Object[] var4 = var2;
+		int var5 = var2.length;
+
+		for(int var6 = 0; var6 < var5; ++var6) {
+			Object var7 = var4[var6];
+			if(var7 instanceof ItemStack) {
+				var3.add(((ItemStack)var7).copy());
+			} else if(var7 instanceof Item) {
+				var3.add(new ItemStack((Item)var7));
+			} else {
+				if(!(var7 instanceof Block)) {
+					throw new RuntimeException("Invalid shapeless recipy!");
+				}
+
+				var3.add(new ItemStack((Block)var7));
+			}
+		}
+
+		this.recipes.add(new ShapelessRecipes(var1, var3));
+	}
+
+	public ItemStack findMatchingRecipe(InventoryCrafting var1) {
 		for(int var2 = 0; var2 < this.recipes.size(); ++var2) {
-			CraftingRecipe var3 = (CraftingRecipe)this.recipes.get(var2);
+			IRecipe var3 = (IRecipe)this.recipes.get(var2);
 			if(var3.matches(var1)) {
 				return var3.getCraftingResult(var1);
 			}
--- /dev/null
+++ net/minecraft/src/Packet130UpdateSign.java
@@ -1,0 +1,61 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet130UpdateSign extends Packet {
+	public int xPosition;
+	public int yPosition;
+	public int zPosition;
+	public String[] signLines;
+
+	public Packet130UpdateSign() {
+		this.isChunkDataPacket = true;
+	}
+
+	public Packet130UpdateSign(int var1, int var2, int var3, String[] var4) {
+		this.isChunkDataPacket = true;
+		this.xPosition = var1;
+		this.yPosition = var2;
+		this.zPosition = var3;
+		this.signLines = var4;
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.xPosition = var1.readInt();
+		this.yPosition = var1.readShort();
+		this.zPosition = var1.readInt();
+		this.signLines = new String[4];
+
+		for(int var2 = 0; var2 < 4; ++var2) {
+			this.signLines[var2] = readString(var1, 15);
+		}
+
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.xPosition);
+		var1.writeShort(this.yPosition);
+		var1.writeInt(this.zPosition);
+
+		for(int var2 = 0; var2 < 4; ++var2) {
+			writeString(this.signLines[var2], var1);
+		}
+
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.handleSignUpdate(this);
+	}
+
+	public int getPacketSize() {
+		int var1 = 0;
+
+		for(int var2 = 0; var2 < 4; ++var2) {
+			var1 += this.signLines[var2].length();
+		}
+
+		return var1;
+	}
+}
